(function(){         var __CORE_MODULE_LIST__ = {"assert":true,"buffer":true,"child_process":true,"cluster":true,"crypto":true,"dgram":true,"dns":true,"events":true,"fs":true,"http":true,"https":true,"net":true,"os":true,"path":true,"punycode":true,"querystring":true,"readline":true,"repl":true,"string_decoder":true,"tls":true,"tty":true,"url":true,"util":true,"vm":true,"zlib":true};         var __MODULE_LOADER__ = function (moduleLoadFunction) {        var fakeModule = {             id: module.id,             parent: module.parent,             filename: module.filename,             loaded: false,             children: [],             paths: module.paths,             exports: {}         };                 return function () {             if (!fakeModule.loaded && !fakeModule.__isLoading) {                 fakeModule.__isLoading = true;                 try {                  moduleLoadFunction(fakeModule, fakeModule.exports);                   fakeModule.__isLoading = false;                } catch (e) {                  fakeModule.__isLoading = false;                  throw e;                }                fakeModule.loaded = true;             }             return fakeModule.exports;         };     };         var __JSON_LOADER__ = function (json) {        return function () {             return JSON.parse(json);         };     };         var __REQUIRED_NODE_MODULES__ = {     "./asyncClient.js":
__MODULE_LOADER__(function(module, exports){

"use strict";


/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
// var http; // require set in initialize()
var cors = __FAKE_REQUIRE__('./cors', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/asyncClient.js");
// var Q = require('q');
var logger = __FAKE_REQUIRE__('./logger', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/asyncClient.js");

var sensorOptions = {};

/*
 * Check if client is properly initialized
 */
var initialized = function() {
  return true; //TODO
};

var simpleType = function(forType) {

  var mappedTypes = {
    "http://purl.imsglobal.org/caliper/v1/ActivityContext": "activityContext",
    "http://purl.imsglobal.org/caliper/v1/Agent": "agent",
    "http://purl.imsglobal.org/caliper/v1/Attempt": "attempt",
    "http://purl.imsglobal.org/caliper/v1/DigitalResource": "digitalResource",
    "http://purl.imsglobal.org/caliper/v1/Entity": "entity",
    "http://purl.imsglobal.org/caliper/v1/LearningObjective": "learningObjective",
    "http://purl.imsglobal.org/caliper/v1/Result": "result",
    "http://purl.imsglobal.org/caliper/v1/View": "view",
    "http://purl.imsglobal.org/caliper/v1/Session": "session",
    "http://purl.imsglobal.org/caliper/v1/Assessment": "quiz",
    "http://purl.imsglobal.org/caliper/v1/AssessmentItem": "quizItem",
    "http://purl.imsglobal.org/caliper/v1/Annotation": "annotation",
    "http://purl.imsglobal.org/caliper/v1/BookmarkAnnotation": "bookmarkAnnotation",
    "http://purl.imsglobal.org/caliper/v1/HighlightAnnotation": "highlightAnnotation",
    "http://purl.imsglobal.org/caliper/v1/SharedAnnotation": "sharedAnnotation",
    "http://purl.imsglobal.org/caliper/v1/TagAnnotation": "tagAnnotation",
    "http://purl.imsglobal.org/caliper/v1/lis/Person": "person",
    "http://purl.imsglobal.org/caliper/v1/lis/Organization": "institution",
    "http://purl.imsglobal.org/caliper/v1/lis/CourseSection": "course",
    "http://purl.imsglobal.org/caliper/v1/AudioObject": "audioObject",
    "http://purl.imsglobal.org/caliper/v1/ImageObject": "imageObject",
    "http://purl.imsglobal.org/caliper/v1/VideoObject": "videoObject",
    "http://purl.imsglobal.org/caliper/v1/MediaLocation": "mediaLocation",
    "http://purl.imsglobal.org/caliper/v1/SoftwareApplication": "edApp",
    "http://purl.imsglobal.org/caliper/v1/AssignableDigitalResource": "assignableDigitalResource",
    "http://www.idpf.org/epub/vocab/structure/#chapter": "ePubChapter",
    "http://www.idpf.org/epub/vocab/structure/#part": "ePubPart",
    "http://www.idpf.org/epub/vocab/structure/#subchapter": "ePubSubChapter",
    "http://www.idpf.org/epub/vocab/structure/#volume": "ePubVolume",
    "http://purl.imsglobal.org/caliper/v1/Frame": "frame",
    "http://purl.imsglobal.org/caliper/v1/MediaObject": "mediaObject",
    "http://www.idpf.org/epub/vocab/structure": "ePubStructure",
    "http://purl.imsglobal.org/caliper/v1/WebPage": "webPage",
  };

  var simpleType = mappedTypes[forType];

  if (_.isUndefined(simpleType)) {
    simpleType = "UNKNOWN";
  }

  return simpleType;
};


/**
 * Initializes the default client to use. Uses the socket consumer by default.
 * @param  array $options passed straight to the client
 */
var initialize = function(options) {
  sensorOptions = options;

  if (_.isUndefined(options.testMode)) {
    sensorOptions.entityURI = '/v1custom/entitydata';
    sensorOptions.eventURI = '/v1custom/eventdata';
    sensorOptions.authURI = '/user/apiToken';
    sensorOptions.refreshTokenURI = '/user/refreshApiToken';
    sensorOptions.queryURI = '/intellisearch';
  } else {
    logger.warn("Sensor is enabled in test mode.  You must provide options.path for correct operation");
  }

  if (!_.isUndefined(sensorOptions.ssl) && sensorOptions.ssl) {
    // http = require('https');
    sensorOptions.protocol = "https://";
  } else {
    // http = require('http');
    sensorOptions.protocol = "http://";
  }

  //logger.log('debug', "Initializing sensor with options " + JSON.stringify(
      //sensorOptions));
};

var addIntellifyMetadata = function(intellifyBaseObj) {
  intellifyBaseObj.apiKey = sensorOptions.apiKey;
  intellifyBaseObj.sensorId = sensorOptions.sensorId;
  intellifyBaseObj.correlationId = sensorOptions.correlationId;
};

// var post = function(postOptions, postData) {

//   var headers = {
//     'Content-Type': 'application/json',
//     'Content-Length': postData.length
//   };

//   postOptions = _.merge(postOptions, {
//     headers: headers
//   });

//   var request = http.request(postOptions, function(response) {
//     logger.log('debug', "finished sending request. Response =" + JSON.stringify(response));
//   });

//   request.write(postData);
//   request.end();

// };

var putCors = function(putOptions, putData) {

  cors.put({
    'method': 'put',
    'url': putOptions.protocol + putOptions.host + putOptions.path,
    'credentials': false,
    'data': putData,
    'headers': {
      "Content-Type": "application/json"
    },
    'success': function(data) {
      logger.info("Successfully PUT learning event" + data);
    },
    'error': function() {
      logger.error("learning event PUT FAILED");
    }
  });

};

var postCors = function(postHeader, postOptions, postParams, postData,
  successCallback, errorCallback) {

  var postUrl = postOptions.protocol + postOptions.host + postOptions.path;
  cors.post({
    'method': 'post',
    'url': postUrl,
    'params': postParams,
    'credentials': false,
    'data': postData,
    'headers': postHeader,
    'success': function(data) {
      //logger.log("debug", "Got data from POST : " + " to path " + postUrl + data);
      //logger.log("Calling success callback");
      successCallback(data);
    },
    'error': function(data) {
      logger.error("POST data FAILED " + " to path " + postUrl + ". Reason : " + data);
      //logger.log("debug", "Calling error callbak");
      errorCallback(data);
    }
  });

};

/**
 * Send learning events
 * @param  CaliperEvent $caliperEvent The Learning Event
 * @return boolean                   whether the measure call succeeded
 */
var measure = function(caliperEvent) {
  if (initialized()) {

    // Create eventData envelope
    var eventData = {};
    eventData.event = caliperEvent;

    if (_.isUndefined(caliperEvent.startedAtTime) || (caliperEvent.startedAtTime ===
      0)) {
      var timestamp = new Date();
      eventData.startedAtTime = timestamp.getTime();
      eventData.timestamp = timestamp.getTime();
    } else {
      eventData.timestamp = caliperEvent.startedAtTime;
    }

    addIntellifyMetadata(eventData);

    // send event
    //logger.log('debug', "Sending event data " + JSON.stringify(eventData));

    var postOptions = _.merge(sensorOptions, {
      method: 'PUT',
      path: sensorOptions.eventURI
    });

    var postData = JSON.stringify(eventData);

    // post(postOptions, postData);
    putCors(postOptions, postData);

  } else {
    logger.error("Sensor is not initialized!! Event will not be sent...");
  }
};

/**
 * Describe an entity
 * @param  CaliperEntity $caliperEntity The Caliper Entity we are describing
 * @return boolean            whether the describe call succeeded
 */
var describe = function(caliperEntity) {

  if (initialized()) {

    // Create entityData envelope
    var entityData = {};
    entityData.entityId = caliperEntity['@id'];
    entityData.type = simpleType(caliperEntity['@type']);
    entityData.entity = caliperEntity;

    if (_.isUndefined(caliperEntity.dateModified) || (caliperEntity.dateModified ===
      0)) {
      var timestamp = new Date();
      entityData.dateModified = timestamp.getTime();
      entityData.timestamp = timestamp.getTime();
    } else {
      entityData.timestamp = caliperEntity.dateModified;
    }

    addIntellifyMetadata(entityData);

    // send entityData
    //logger.log('debug', "Sending entityData " + JSON.stringify(entityData));

    var postOptions = _.merge(sensorOptions, {
      method: 'PUT',
      path: sensorOptions.entityURI
    });

    var postData = JSON.stringify(entityData);

    // post(postOptions, postData);
    putCors(postOptions, postData);

  } else {
    logger.error("Sensor is not initialized!! Describe will not be sent...");
  }
};

/**
 * Authenticate at Intellify service using provided credentials and return a token
 * @param  User $user The user (name and password) to login
 * @param long $expiryInSeconds Token expiration duration in seconds
 * @param Function $successCallback Success callback function
 * @param Function $errorCallback Error callback function
 */
var authenticate = function(user, expiryInSeconds, successCallback,
  errorCallback) {

  if (initialized()) {

    //send user credentials
    /*logger.log('debug', "Sending user credentials to login " + JSON.stringify(
        user));*/

    var postOptions = _.merge(sensorOptions, {
      method: 'POST',
      path: sensorOptions.authURI
    });

    var postData = JSON.stringify(user);

    var postHeader = {};
    postHeader['Content-Type'] = "application/json";

    var postParams = {};
    postParams.expiryInSeconds = expiryInSeconds;
    var successFunction = function(data) {
      //NOTE: We don't get HTTP status code; hence need to check if we got apiToken in the response
      try {
        var res = JSON.parse(data);
        //Check if we got the apiToken
        if (_.isUndefined(res.apiToken)) {
          //logger.log('error in authentication: ' + data);
          errorCallback("Unauthorized");
        } else {
          //We got the token here
          successCallback(res.apiToken);
        }
      } catch (e) {
      //No password in the response, assume unauthorized error
      errorCallback("Unauthorized");
      }

    };

    var errorFunction = function(data) {
      //logger.log('debug', data);
      errorCallback(data);
    };

    postCors(postHeader, postOptions, postParams, postData, successFunction,
      errorFunction);

  } else {
    //logger.log('error',
      //"Sensor is not initialized!! Auth request will not be sent...");
  }
};

/**
 * Refresh token at Intellify service using logged-in token and return a refresh token
 * @param  String $token The authentication token for the login user
 * @param long $expiryInSeconds Token expiration duration in seconds
 * @param Function $successCallback Success callback function
 * @param Function $errorCallback Error callback function
 */
var refreshToken = function(token, expiryInSeconds, successCallback,
  errorCallback) {

  if (initialized()) {

    //send refresh token
    /*logger.log('debug', "Sending token for refresh " + token));*/

    var postOptions = _.merge(sensorOptions, {
      method: 'POST',
      path: sensorOptions.refreshTokenURI
    });

    var postData = "{}";

    var postHeader = {};
    postHeader['Content-Type'] = "application/json";
    postHeader.Authorization = "Bearer " + token;

    var postParams = {};
    postParams.expiryInSeconds = expiryInSeconds;
    var successFunction = function(data) {
      //NOTE: We don't get HTTP status code; hence need to check if we got apiToken in the response
      try {
        var res = JSON.parse(data);
        //Check if we got the apiToken
        if (_.isUndefined(res.apiToken)) {
          //logger.log('error in refresh token: ' + data);
          errorCallback("Unauthorized");
        } else {
          //We got the token here
          successCallback(res.apiToken);
        }
      } catch (e) {
      //No password in the response, assume unauthorized error
      errorCallback("Unauthorized");
      }

    };

    var errorFunction = function(data) {
      //logger.log('debug', data);
      errorCallback(data);
    };

    postCors(postHeader, postOptions, postParams, postData, successFunction,
      errorFunction);

  } else {
    //logger.log('error',
      //"Sensor is not initialized!! Auth request will not be sent...");
  }
};

/**
 * Query an Intellify stream and return the result
 * @param  String $token The authentication token for the login user
 * @param String $stream Name of the stream to be searched
 * @param boolean $isDynamic True if this is dynamic query
 * @param String $urlParams URL parameters if any
 * @param String $requestBody JSON query string which will be the request body
 * @param Function $successCallback Success callback function
 * @param Function $errorCallback Error callback function
 */

var query = function(token, stream, isDynamic, urlParams, requestBody, successCallback,
  errorCallback) {

  if (initialized()) {

    //send user credentials
    //logger.log('debug', "Querying stream " + stream);
    //logger.log('debug', "Query URL params " + urlParams);
    //logger.log('debug', "Query request body " + requestBody);

    var postOptions = _.merge(sensorOptions, {
      method: 'POST',
      path: sensorOptions.queryURI + "/" + (isDynamic? "dynamic/" + stream : stream + "/_search"),
    });


    var postHeader = {};
    postHeader['Content-Type'] = "application/json";
    postHeader.Authorization = "Bearer " + token;


    var successFunction = function(data) {
      //NOTE: We don't get HTTP status code;
      //So we look for 'error' in data.
      try {
        var res = JSON.parse(data);
        //Check if we did not get any error
        if (_.isUndefined(res.error)) {
          //We got the valid query response here
          //TODO : Hide ES specific fields from the caller
          //logger.log('debug', "Query result : " + data);
          successCallback(data);
        } else {
          //logger.log('error in query: ' + data);
          errorCallback(data);
        }
      } catch (e) {
      //No password in the response, assume unauthorized error
      errorCallback("Bad query response format");
      }
    };

    var errorFunction = function(data) {
      //logger.log('debug', "Query error " + data);
      errorCallback(data);
    };

    postCors(postHeader, postOptions, urlParams, requestBody, successFunction,
      errorFunction);

  } else {
    //logger.log('error',
      //"Sensor is not initialized!! Auth request will not be sent...");
  }
};

module.exports = {
  initialize: initialize,
  measure: measure,
  describe: describe,
  authenticate: authenticate,
  refreshToken: refreshToken,
  query: query
};


})
, "./cors.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
var _ = require('lodash-node');
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */
var win = (typeof window !== "undefined") ? window : {};

var CORSxhr = (function() {
  var xhr;

  if (win.XMLHttpRequest && ('withCredentials' in new win.XMLHttpRequest())) {
    xhr = win.XMLHttpRequest;

  } else if (win.XDomainRequest) {
    xhr = win.XDomainRequest;
  }

  return xhr;
}());

var methods = ['head', 'get', 'post', 'put', 'delete'];
var methodsLength = methods.length;
var cors = {};

var i = 0;


function toQueryString(params) {
  var key,
    queryString = [];

  for (key in params) {
    queryString.push((encodeURIComponent(key) + '=' + encodeURIComponent(params[key])));
  }

  return queryString.join('&');
}

function Request(options) {
  this.init(options);
}

Request.prototype.init = function(options) {
  var that = this;

  that.xhr = new CORSxhr();
  that.method = options.method;
  that.url = options.url;
  that.success = options.success;
  that.error = options.error;
  that.params = options.params;
  that.headers = options.headers;
  that.data = options.data;

  if (options.credentials === true) {
    that.xhr.withCredentials = true;
  }

  if (typeof options.params === "object") {
    that.params = toQueryString(options.params);
  }

  that.send();

  return that;
};

Request.prototype.send = function() {
  var that = this;

  // Success callback
  if (that.success !== undefined) {
    that.xhr.onload = function() {
      that.success.call(this, this.responseText);
    };
  }

  // Error callback
  if (that.error !== undefined) {
    that.xhr.error = function() {
      that.error.call(this, this.responseText);
    };
  }

  that.xhr.open(that.method, that.url, true);

  if (that.headers !== undefined) {
    that.setHeaders();
  }

  // Send
  that.xhr.send(that.data);

  return that;
};

Request.prototype.setHeaders = function() {
  var that = this,
    headers = that.headers,
    key;

  for (key in headers) {
    if (headers.hasOwnProperty(key)) {
      that.xhr.setRequestHeader(key, headers[key]);
    }
  }

  return that;
};

function getCorsForMethod(method) {
  return function(url, success) {
    var options = {};

    if (url === undefined) {
      throw new Error('CORS: url must be defined');
    }

    if (typeof url === 'object') {
      options = url;

    } else {
      if (typeof success === 'function') {
        options.success = success;
      }

      options.url = url;
    }

    options.method = method.toUpperCase();

    return new Request(options);
  };
}

/**
 * Public Methods
 */
for (i; i < methodsLength; i += 1) {
  var method = methods[i];
  cors[method] = getCorsForMethod(method);
}

/**
 * Expose cors
 */
module.exports = cors;


})
, "./logger.js":
__MODULE_LOADER__(function(module, exports){

"use strict";

var _ = require('lodash-node');
var console;

if (!_.isUndefined(global) && global.console) {
  console = global.console;
} else if (!_.isUndefined(window) && window.console) {
  console = window.console;
} else {
  console = {};
}

var functions = [
  [log, "log"],
  [info, "info"],
  [warn, "warn"],
  [error, "error"]
];

for (var i = 0; i < functions.length; i++) {
  var tuple = functions[i];
  var f = tuple[0];
  var n = tuple[1];

  if (!console[n]) {
    console[n] = f;
  }
}

module.exports = console;

function log() {}

function info() {
  console.log.apply(console, arguments);
}

function warn() {
  console.log.apply(console, arguments);
}

function error() {
  console.warn.apply(console, arguments);
}


})
, "./actions/annotationActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Annotation Metric Profile
 * @readonly
 * @enum {string}
 */
var annotationActions = {
  "ATTACHED": "attached",
  "BOOKMARKED": "bookmarked",
  "CLASSIFIED": "classified",
  "COMMENTED": "commented",
  "DESCRIBED": "described",
  "HIGHLIGHTED": "highlighted",
  "IDENTIFIED": "identified",
  "LIKED": "liked",
  "LINKED": "linked",
  "RANKED": "ranked",
  "QUESTIONED": "questioned",
  "RECOMMENDED": "recommended",
  "REPLIED": "replied",
  "SHARED": "shared",
  "SUBSCRIBED": "subscribed",
  "TAGGED": "tagged",
  "NAVIGATED_TO": "navigatedTo"
};

module.exports = annotationActions;

})
, "./actions/assessmentActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Assessment Metric Profile
 * @readonly
 * @enum {string}
 */
var assessmentActions = {
  "STARTED": "started",
  "PAUSED": "paused",
  "RESTARTED": "restarted",
  "SUBMITTED": "submitted",
  "NAVIGATED_TO": "navigatedTo"
};

module.exports = assessmentActions;


})
, "./actions/assessmentItemActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Assessment Metric Profile (Items)
 * @readonly
 * @enum {string}
 */
var assessmentItemActions = {
  "STARTED": "started",
  "COMPLETED": "completed",
  "SKIPPED": "skipped",
  "REVIEWED": "reviewed",
  "VIEWED": "viewed",
  "NAVIGATED_TO": "navigatedTo"
};

module.exports = assessmentItemActions;


})
, "./actions/assignableActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Assignable Metric Profile
 * @readonly
 * @enum {string}
 */
var assignableActions = {
  "ABANDONED": "abandoned",
  "ACTIVATED": "activated",
  "COMPLETED": "completed",
  "DEACTIVATED": "deactivated",
  "HID": "hid",
  "REVIEWED": "reviewed",
  "SHOWED": "showed",
  "STARTED": "started",
  "SUBMITTED": "submitted",
  "NAVIGATED_TO": "navigatedTo"
};

module.exports = assignableActions;


})
, "./actions/mediaActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Media Metric Profile
 * @readonly
 * @enum {string}
 */
var mediaActions = {
  "ENABLEDCLOSECAPTIONING": "enabledCloseCaptioning",
  "DISABLEDCLOSEDCAPTIONING": "disabledCloseCaptioning",
  "CHANGEDVOLUME": "changedVolume",
  "MUTED": "muted",
  "UNMUTED": "unmuted",
  "CHANGEDSPEED": "changedSpeed",
  "ENDED": "ended",
  "JUMPEDTO": "jumpedTo",
  "FORWARDEDTO": "forwardedTo",
  "PAUSED": "paused",
  "RESUMED": "resumed",
  "REWINDED": "rewindedTo",
  "STARTED": "started",
  "CHANGEDRESOLUTION": "changedResolution",
  "CHANGEDVIEWERSIZE": "changedViewerSize",
  "CLOSEDPOPOUT": "closedPopout",
  "ENTEREDFULLSCREEN": "enteredFullScreen",
  "EXITEDFULLSCREEN": "exitedFullScreen",
  "OPENEDPOPOUT": "openedPopout",
  "NAVIGATED_TO": "navigatedTo"
};

module.exports = mediaActions;


})
, "./actions/outcomeActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Outcome Metric Profile
 * @readonly
 * @enum {string}
 */
var outcomeActions = {
  "GRADED" : "graded",
  "POSTED" : "posted",
  "REPORTED": "reported",
  "NAVIGATED_TO": "navigatedTo",
};

module.exports = outcomeActions;


})
, "./actions/readingActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Reading Metric Profile
 * @readonly
 * @enum {string}
 */
var readingActions = {
  "SEARCHED": "searched",
  "VIEWED": "viewed",
  "NAVIGATED_TO": "navigated to"
};

module.exports = readingActions;


})
, "./actions/sessionActions.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 * Enum for Actions for the Session Metric Profile
 * @readonly
 * @enum {string}
 */
var sessionActions = {
  "LOGGED_IN"  : "loggedIn",
  "LOGGED_OUT" : "loggedOut",
  "TIMED_OUT"  : "timedOut",
  "STARTED"    : "started",
  "COMPLETED"  : "completed"
};

module.exports = sessionActions;


})
, "./entities/caliperEntity.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 *
 * Entities are used to describe objects that are part of an Event
 *
 * Note that you would not typically use a generic Entity, but rather a specific type (e.g. VideoObject)

 *  Here is an example:
 * <pre><code>
 * var quiz = new Assessment("https://some-university.edu/politicalScience/2014/american-revolution-101/assessment1");
 * quiz.setName("American Revolution - Key Figures Assessment");
 * quiz.setIsPartOf("https://some-university.edu/politicalScience/2014/american-revolution-101");
 * quiz.setDateModified(1402965614516);
 * quiz.setDateCreated(1402965614516);
 * quiz.setDatePublished(1402965614516);
 * quiz.setDateToActivate(1402965614516);
 * quiz.setDateToShow(1402965614516);
 * quiz.setDateToStartOn(1402965614516);
 * quiz.setDateToSubmit(1402965614516);
 * quiz.setMaxAttempts(2);
 * quiz.setMaxSubmits(2);
 * quiz.setMaxScore(3.0);
 *  @constructor
 */
function Entity() {
  // Constructor
}

/**
 * Set the event id
 *  Note that this manifests as a JSON-LD @id
 *
 * @param {string} id - id URI
 */
Entity.prototype.setId = function(id) {
  this['@id'] = id;
};

/**
 * Set the event type
 *  Note that this manifests as a JSON-LD @type
 *
 * @param {string} type - id type
 */
Entity.prototype.setType = function(type) {
  this['@type'] = type;
};

/**
 * Set the event name
 *
 * @param {string} name - name
 */
Entity.prototype.setName = function(name) {
  this.name = name;
};

/**
 * Set the event description
 *
 * @param {string} description - description
 */
Entity.prototype.setDescription = function(description) {
  this.description = description;
};

/**
 * Set addtional (custom) properties
 *
 * @param {map} properties - properties
 */
Entity.prototype.setProperties = function(properties) {
  this.properties = properties;
};

/**
 * Set the time the entity was created
 *  A ISO-8601 date
 *
 * @param {string} dateCreated - string representing datetime
 */
Entity.prototype.setDateCreated = function(dateCreated) {
  this.dateCreated = dateCreated;
};

/**
 * Set the time the entity was last modified
 *  A ISO-8601 date
 *
 * @param {string} dateModified - string representing datetime
 */
Entity.prototype.setDateModified = function(dateModified) {
  this.dateModified = dateModified;
};

/**
 * Enum for JSON-LD types of entities
 * @readonly
 * @enum {string}
 */
Entity.prototype.Types = {
  "ACTIVITY_CONTEXT": "http://purl.imsglobal.org/caliper/v1/ActivityContext",
  "AGENT": "http://purl.imsglobal.org/caliper/v1/Agent",
  "ATTEMPT": "http://purl.imsglobal.org/caliper/v1/Attempt",
  "DIGITAL_RESOURCE": "http://purl.imsglobal.org/caliper/v1/DigitalResource",
  "ENTITY": "http://purl.imsglobal.org/caliper/v1/Entity",
  "LEARNING_OBJECTIVE": "http://purl.imsglobal.org/caliper/v1/LearningObjective",
  "RESULT": "http://purl.imsglobal.org/caliper/v1/Result",
  "VIEW": "http://purl.imsglobal.org/caliper/v1/View",
  "SESSION": "http://purl.imsglobal.org/caliper/v1/Session"
};

module.exports = Entity;


})
, "./entities/agent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('./caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/agent.js");

/**
 *
 * Entity type: Agent
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Agent
 *
 * Construct as follows:
 * <pre><code>
 * var myUser = new new Intellify.Entities.Agent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function Agent(id, type) {

  Entity.call(this);

  this.setId(id);

  switch (type) {
  case "LIS_PERSON":
    this.setType("http://purl.imsglobal.org/caliper/v1/lis/Person");
    break;
  case "LIS_COURSE_SECTION":
    this.setType("http://purl.imsglobal.org/caliper/v1/lis/CourseSection");
    break;
  case "LIS_ORGANIZATION":
    this.setType("http://purl.imsglobal.org/caliper/v1/lis/Organization");
    break;
  case "SOFTWARE_APPLICATION":
    this.setType("http://purl.imsglobal.org/caliper/v1/SoftwareApplication");
    break;
  }

  this.setName(null);
  this.setDescription(null);
  this.setProperties({});
}

Agent.prototype = _.create(Entity.prototype);

module.exports = Agent;


})
, "./entities/digitalResource.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('./caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/digitalResource.js");

/**
 *
 * Entity type: DigitalResource
 *
 * A DigitalResource is the base type for all digital content
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/DigitalResource
 *
 * Construct as follows:
 * <pre><code>
 * var myUser = new new Intellify.Entities.DigitalResource("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function DigitalResource(id) {

  Entity.call(this);

  this.setId(id);

  this.setName(null);
  this.setDescription(null);
  this.setProperties({});
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
  this.setDatePublished(0);
}

DigitalResource.prototype = _.create(Entity.prototype);

DigitalResource.prototype.setResourceType = function (type) {
  switch (type) {
  case "ASSIGNABLE_DIGITAL_RESOURCE":
    this.setType("http://purl.imsglobal.org/caliper/v1/AssignableDigitalResource");
    break;
  case "EPUB_CHAPTER":
    this.setType("http://www.idpf.org/epub/vocab/structure/#chapter");
    break;
  case "EPUB_PART":
    this.setType("http://www.idpf.org/epub/vocab/structure/#part");
    break;
  case "EPUB_SUB_CHAPTER":
    this.setType("http://www.idpf.org/epub/vocab/structure/#subchapter");
    break;
  case "EPUB_VOLUME":
    this.setType("http://www.idpf.org/epub/vocab/structure/#volume");
    break;
  case "FRAME":
    this.setType("http://purl.imsglobal.org/caliper/v1/Frame");
    break;
  case "MEDIA_OBJECT":
    this.setType("http://purl.imsglobal.org/caliper/v1/MediaObject");
    break;
  case "READING":
    this.setType("http://www.idpf.org/epub/vocab/structure");
    break;
  case "WEB_PAGE":
    this.setType("http://purl.imsglobal.org/caliper/v1/WebPage");
    break;
  }
};

DigitalResource.prototype.setObjectType = function (objectType) {
  this.objectType = objectType;
};

DigitalResource.prototype.setAlignedLearningObjective = function (alignedLearningObjective) {
  this.alignedLearningObjective = alignedLearningObjective;
};

DigitalResource.prototype.setKeywords = function (keywords) {
  this.keywords = keywords;
};

DigitalResource.prototype.setIsPartOf = function (isPartOf) {
  this.isPartOf = isPartOf;
};

DigitalResource.prototype.setDatePublished = function (datePublished) {
  this.datePublished = datePublished;
};

/**
 * Enum for JSON-LD types of digital resources
 * @readonly
 * @enum {string}
 */
DigitalResource.prototype.Types = {
  "ASSIGNABLE_DIGITAL_RESOURCE": "http://purl.imsglobal.org/caliper/v1/AssignableDigitalResource",
  "EPUB_CHAPTER": "http://www.idpf.org/epub/vocab/structure/#chapter",
  "EPUB_PART": "http://www.idpf.org/epub/vocab/structure/#part",
  "EPUB_SUB_CHAPTER": "http://www.idpf.org/epub/vocab/structure/#subchapter",
  "EPUB_VOLUME": "http://www.idpf.org/epub/vocab/structure/#volume",
  "FRAME": "http://purl.imsglobal.org/caliper/v1/Frame",
  "MEDIA_OBJECT": "http://purl.imsglobal.org/caliper/v1/MediaObject",
  "READING": "http://www.idpf.org/epub/vocab/structure",
  "WEB_PAGE": "http://purl.imsglobal.org/caliper/v1/WebPage"
};

module.exports = DigitalResource;


})
, "./entities/learningObjective.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('./caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/learningObjective.js");

/**
 *
 * Entity type: LearningObjective
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/LearningObjective
 *
 * Construct as follows:
 * <pre><code>
 * var aLearningObjective = new new Intellify.Entities.LearningObjective("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function LearningObjective(id) {

  Entity.call(this);

  this.setId(id);
  this.setType(this.Types.LEARNING_OBJECTIVE);

  this.setName(null);
  this.setProperties({});
}

LearningObjective.prototype = _.create(Entity.prototype);

module.exports = LearningObjective;


})
, "./entities/softwareApplication.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Agent = __FAKE_REQUIRE__('./agent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/softwareApplication.js");

/**
 *
 * Entity type: SoftwareApplication
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/SoftwareApplication
 *
 * Construct as follows:
 * <pre><code>
 * var myEdApp = new new Intellify.Entities.SoftwareApplication("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function SoftwareApplication(id) {

  Agent.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/SoftwareApplication");

}

SoftwareApplication.prototype = _.create(Agent.prototype);

module.exports = SoftwareApplication;


})
, "./entities/webPage.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = __FAKE_REQUIRE__('./digitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/webPage.js");

/**
 *
 * Entity type: WebPage
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/WebPage
 *
 * Construct as follows:
 * <pre><code>
 * var myWebPage = new new Intellify.Entities.WebPage("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function WebPage(id) {

  DigitalResource.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/WebPage");

  this.setName(null);
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
}

WebPage.prototype = _.create(DigitalResource.prototype);

module.exports = WebPage;


})
, "./entities/user.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Sachin Kulkarni
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 *
 * User entity to encapsulate login credentials
 *
 * <pre><code>
 * var user = new User("user_name", "user_password");
 * <pre><code>
 *  @constructor
 */
function User(name, password) {
  this.setUserName(name);
  this.setUserPassword(password);
}

/**
 * Set the username
 *
 * @param {string} name - user name
 */
User.prototype.setUserName = function(name) {
  this.username = name;
};

/**
 * Set the password
 *
 * @param {string} password - user password
 */
User.prototype.setUserPassword = function(password) {
  this.password = password;
};

module.exports = User;


})
, "./entities/lis/person.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Agent = __FAKE_REQUIRE__('../agent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/lis/person.js");

/**
 *
 * Entity type: Person
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Person
 *
 * Represents an Person (e.g. a user, student)
 *
 * Construct as follows:
 * <pre><code>
 * var myPerson = new new Intellify.Entities.Person("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Agent
 */
function Person(id) {

  Agent.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/lis/Person");

}

Person.prototype = _.create(Agent.prototype);

Person.prototype.setFirstName = function(firstName) {
  this.firstName = firstName;
};

Person.prototype.setLastName = function(lastName) {
  this.lastName = lastName;
};

Person.prototype.setEmail = function(email) {
  this.email = email;
};

Person.prototype.setRoles = function(roles) {
  this.roles = roles;
};

module.exports = Person;


})
, "./entities/lis/courseSection.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Organization = __FAKE_REQUIRE__('./organization', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/lis/courseSection.js");

/**
 *
 * Entity type: CourseSection
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/CourseSection
 *
 * Represents an CourseSection (e.g. a class, section, )
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.CourseSection("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Organization
 */
function CourseSection(id) {

  Organization.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/lis/CourseSection");

  this.setParentOrg(null);

}

CourseSection.prototype = _.create(Organization.prototype);

CourseSection.prototype.setSemester = function(semester) {
  this.semester = semester;
};

CourseSection.prototype.setCourseNumber = function(courseNumber) {
  this.courseNumber = courseNumber;
};

CourseSection.prototype.setLabel = function(label) {
  this.label = label;
};

module.exports = CourseSection;


})
, "./entities/lis/organization.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Agent = __FAKE_REQUIRE__('../agent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/lis/organization.js");

/**
 *
 * Entity type: Organization
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Organization
 *
 * Represents an Organization (e.g. a School, College, etc.)
 *
 * Construct as follows:
 * <pre><code>
 * var myOrganization = new new Intellify.Entities.Organization("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Agent
 */
function Organization(id) {

  Agent.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/lis/Organization");

  this.setName(null);
}

Organization.prototype = _.create(Agent.prototype);

Organization.prototype.setParentOrg = function(parentOrg) {
  this.parentOrg = parentOrg;
};

module.exports = Organization;


})
, "./entities/annotation/annotation.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('../caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/annotation.js");

/**
 *
 * Entity type: Annotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Annotation
 *
 * Construct as follows:
 * <pre><code>
 * var myAnnotation = new new Intellify.Entities.Annotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function Annotation(id) {

  Entity.call(this);

  this.setId(id);

  this.setName(null);
  this.setDescription(null);
  this.setProperties({});
}

Annotation.prototype = _.create(Entity.prototype);

Annotation.prototype.setAnnotationType = function(type) {
  switch (type) {
    case "ANNOTATION":
      this.setType("http://purl.imsglobal.org/caliper/v1/Annotation");
      break;
    case "BOOKMARK_ANNOTATION":
      this.setType("http://purl.imsglobal.org/caliper/v1/BookmarkAnnotation");
      break;
    case "HIGHLIGHT_ANNOTATION":
      this.setType("http://purl.imsglobal.org/caliper/v1/HighlightAnnotation");
      break;
    case "SHARED_ANNOTATION":
      this.setType("http://purl.imsglobal.org/caliper/v1/SharedAnnotation");
      break;
    case "TAG_ANNOTATION":
      this.setType("http://purl.imsglobal.org/caliper/v1/TagAnnotation");
      break;
  }
};

/**
 * Enum for JSON-LD types of annotations
 * @readonly
 * @enum {string}
 */
Annotation.prototype.annotationTypes = {
  "BOOKMARK_ANNOTATION": "http://purl.imsglobal.org/caliper/v1/BookmarkAnnotation",
  "HIGHLIGHT_ANNOTATION": "http://purl.imsglobal.org/caliper/v1/HighlightAnnotation",
  "SHARED_ANNOTATION": "http://purl.imsglobal.org/caliper/v1/SharedAnnotation",
  "TAG_ANNOTATION": "http://purl.imsglobal.org/caliper/v1/TagAnnotation"
};


module.exports = Annotation;


})
, "./entities/annotation/bookmarkAnnotation.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = __FAKE_REQUIRE__('./annotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/bookmarkAnnotation.js");

/**
 *
 * Entity type: BookmarkAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/BookmarkAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var myBookmarkAnnotation = new new Intellify.Entities.BookmarkAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function BookmarkAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

BookmarkAnnotation.prototype = _.create(Annotation.prototype);

BookmarkAnnotation.prototype.setBookmarkNotes = function (bookmarkNotes) {
  this.bookmarkNotes = bookmarkNotes;
};

module.exports = BookmarkAnnotation;


})
, "./entities/annotation/highlightAnnotation.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = __FAKE_REQUIRE__('./annotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/highlightAnnotation.js");

/**
 *
 * Entity type: HighlightAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/HighlightAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var myHighlightAnnotation = new new Intellify.Entities.HighlightAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function HighlightAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

HighlightAnnotation.prototype = _.create(Annotation.prototype);

HighlightAnnotation.prototype.setSelection = function (selection) {
  this.selection = selection;
};

HighlightAnnotation.prototype.setSelectionText = function (selectionText) {
  this.selectionText = selectionText;
};

module.exports = HighlightAnnotation;


})
, "./entities/annotation/sharedAnnotation.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = __FAKE_REQUIRE__('./annotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/sharedAnnotation.js");

/**
 *
 * Entity type: SharedAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/SharedAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var mySharedAnnotation = new new Intellify.Entities.SharedAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function SharedAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

SharedAnnotation.prototype = _.create(Annotation.prototype);

SharedAnnotation.prototype.setWithAgents = function (withAgents) {
  this.withAgents = withAgents;
};

module.exports = SharedAnnotation;


})
, "./entities/annotation/tagAnnotation.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = __FAKE_REQUIRE__('./annotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/tagAnnotation.js");

/**
 *
 * Entity type: TagAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/TagAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var myTagAnnotation = new new Intellify.Entities.TagAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function TagAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

TagAnnotation.prototype = _.create(Annotation.prototype);

TagAnnotation.prototype.setTags = function (tags) {
  this.tags = tags;
};

module.exports = TagAnnotation;


})
, "./entities/assignable/assignableDigitalResource.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = __FAKE_REQUIRE__('../DigitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assignable/assignableDigitalResource.js");

/**
 *
 * Entity type: AssignableDigitalResource
 *
 * A AssignableDigitalResource is the base type for all digital content that is assignable (e.g. quizzes, homework, etc.)
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/AssignableDigitalResource
 *
 * Construct as follows:
 * <pre><code>
 * var myUser = new new Intellify.Entities.AssignableDigitalResource("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function AssignableDigitalResource(id) {

  DigitalResource.call(this);

  this.setId(id);
  this.setType(this.Types.ASSIGNABLE_DIGITAL_RESOURCE);

  this.setProperties({});
  this.setDateCreated(0);
  this.setDateToActivate(0);
  this.setDateToShow(0);
  this.setDateToStartOn(0);
  this.setDateToSubmit(0);
  this.setMaxAttempts(0);
  this.setMaxSubmits(0);
  this.setMaxScore(0);
}

AssignableDigitalResource.prototype = _.create(DigitalResource.prototype);

AssignableDigitalResource.prototype.setDateCreated = function (dateCreated) {
  this.dateCreated = dateCreated;
};

AssignableDigitalResource.prototype.setDateToActivate = function (dateToActivate) {
  this.dateToActivate = dateToActivate;
};

AssignableDigitalResource.prototype.setDateToShow = function (dateToShow) {
  this.dateToShow = dateToShow;
};

AssignableDigitalResource.prototype.setDateToStartOn = function (dateToStartOn) {
  this.dateToStartOn = dateToStartOn;
};

AssignableDigitalResource.prototype.setDateToSubmit = function (dateToSubmit) {
  this.dateToSubmit = dateToSubmit;
};

AssignableDigitalResource.prototype.setMaxAttempts = function (maxAttempts) {
  this.maxAttempts = maxAttempts;
};

AssignableDigitalResource.prototype.setMaxSubmits = function (maxSubmits) {
  this.maxSubmits = maxSubmits;
};

AssignableDigitalResource.prototype.setMaxScore = function (maxScore) {
  this.maxScore = maxScore;
};

/**
 * Enum for JSON-LD types of assignable digital resources
 * @readonly
 * @enum {string}
 */
AssignableDigitalResource.prototype.Types = {
  "ASSESSMENT": "http://purl.imsglobal.org/caliper/v1/Assessment",
  "ASSESSMENT_ITEM": "http://purl.imsglobal.org/caliper/v1/AssessmentItem"
};


module.exports = AssignableDigitalResource;


})
, "./entities/DigitalResource.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('./caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/DigitalResource.js");

/**
 *
 * Entity type: DigitalResource
 *
 * A DigitalResource is the base type for all digital content
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/DigitalResource
 *
 * Construct as follows:
 * <pre><code>
 * var myUser = new new Intellify.Entities.DigitalResource("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function DigitalResource(id) {

  Entity.call(this);

  this.setId(id);

  this.setName(null);
  this.setDescription(null);
  this.setProperties({});
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
  this.setDatePublished(0);
}

DigitalResource.prototype = _.create(Entity.prototype);

DigitalResource.prototype.setResourceType = function (type) {
  switch (type) {
  case "ASSIGNABLE_DIGITAL_RESOURCE":
    this.setType("http://purl.imsglobal.org/caliper/v1/AssignableDigitalResource");
    break;
  case "EPUB_CHAPTER":
    this.setType("http://www.idpf.org/epub/vocab/structure/#chapter");
    break;
  case "EPUB_PART":
    this.setType("http://www.idpf.org/epub/vocab/structure/#part");
    break;
  case "EPUB_SUB_CHAPTER":
    this.setType("http://www.idpf.org/epub/vocab/structure/#subchapter");
    break;
  case "EPUB_VOLUME":
    this.setType("http://www.idpf.org/epub/vocab/structure/#volume");
    break;
  case "FRAME":
    this.setType("http://purl.imsglobal.org/caliper/v1/Frame");
    break;
  case "MEDIA_OBJECT":
    this.setType("http://purl.imsglobal.org/caliper/v1/MediaObject");
    break;
  case "READING":
    this.setType("http://www.idpf.org/epub/vocab/structure");
    break;
  case "WEB_PAGE":
    this.setType("http://purl.imsglobal.org/caliper/v1/WebPage");
    break;
  }
};

DigitalResource.prototype.setObjectType = function (objectType) {
  this.objectType = objectType;
};

DigitalResource.prototype.setAlignedLearningObjective = function (alignedLearningObjective) {
  this.alignedLearningObjective = alignedLearningObjective;
};

DigitalResource.prototype.setKeywords = function (keywords) {
  this.keywords = keywords;
};

DigitalResource.prototype.setIsPartOf = function (isPartOf) {
  this.isPartOf = isPartOf;
};

DigitalResource.prototype.setDatePublished = function (datePublished) {
  this.datePublished = datePublished;
};

/**
 * Enum for JSON-LD types of digital resources
 * @readonly
 * @enum {string}
 */
DigitalResource.prototype.Types = {
  "ASSIGNABLE_DIGITAL_RESOURCE": "http://purl.imsglobal.org/caliper/v1/AssignableDigitalResource",
  "EPUB_CHAPTER": "http://www.idpf.org/epub/vocab/structure/#chapter",
  "EPUB_PART": "http://www.idpf.org/epub/vocab/structure/#part",
  "EPUB_SUB_CHAPTER": "http://www.idpf.org/epub/vocab/structure/#subchapter",
  "EPUB_VOLUME": "http://www.idpf.org/epub/vocab/structure/#volume",
  "FRAME": "http://purl.imsglobal.org/caliper/v1/Frame",
  "MEDIA_OBJECT": "http://purl.imsglobal.org/caliper/v1/MediaObject",
  "READING": "http://www.idpf.org/epub/vocab/structure",
  "WEB_PAGE": "http://purl.imsglobal.org/caliper/v1/WebPage"
};

module.exports = DigitalResource;


})
, "./entities/assignable/attempt.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('../caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assignable/attempt.js");

/**
 *
 * Entity type: Attempt
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Attempt
 *
 * Represents an Attempt (e.g. for a quiz, question, etc.)
 *
 * Construct as follows:
 * <pre><code>
 * var myAttempt = new new Intellify.Entities.Attempt("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function Attempt(id) {

  Entity.call(this);

  this.setId(id);
  this.setType(this.Types.ATTEMPT);

  this.setProperties({});
}

Attempt.prototype = _.create(Entity.prototype);

/**
 * Set the the attempt startedAtTime
 *
 * @param {long} startedAtTime
 */
Attempt.prototype.setStartedAtTime = function (startedAt) {
  this.startedAtTime = startedAt;
};

/**
 * Set the the attempt endedAtTime
 *
 * @param {long} endedAtTime
 */
Attempt.prototype.setEndedAtTime = function (endedAt) {
  this.endedAtTime = endedAt;
};

/**
 * Set the the attempt duration
 *
 * @param {long} duration
 */
Attempt.prototype.setDuration = function (duration) {
  this.duration = duration;
};

/**
 * Set the the assignable (for which Result is being reported)
 *
 * @param {string} assignableId
 */
Attempt.prototype.setAssignableId = function (assignableId) {
  this.assignable = assignableId;
};

/**
 * Set the the actor (who's attempt is being reported on by Result)
 *
 * @param {string} actorId
 */
Attempt.prototype.setActorId = function (actorId) {
  this.actor = actorId;
};

/**
 * Set the the attempt count
 *
 * @param {long} count
 */
Attempt.prototype.setCount = function (count) {
  this.count = count;
};

module.exports = Attempt;


})
, "./entities/assessment/assessment.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AssignableDigitalResource = __FAKE_REQUIRE__('../assignable/assignableDigitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assessment/assessment.js");

/**
 *
 * Entity type: Assessment
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Assessment
 *
 * Represents an Assessment (e.g. a quiz, homework)
 *
 * Construct as follows:
 * <pre><code>
 * var myAssessment = new new Intellify.Entities.Assessment("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function Assessment(id) {

  AssignableDigitalResource.call(this);

  this.setId(id);
  this.setType(this.Types.ASSESSMENT);

  this.setProperties({});
}

Assessment.prototype = _.create(AssignableDigitalResource.prototype);

Assessment.prototype.setAssessmentItems = function (assessmentItems) {
  this.assessmentItems = assessmentItems;
};

module.exports = Assessment;


})
, "./entities/assessment/assessmentItem.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AssignableDigitalResource = __FAKE_REQUIRE__('../assignable/assignableDigitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assessment/assessmentItem.js");

/**
 *
 * Entity type: AssessmentItem
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/AssessmentItem
 *
 * Represents an AssessmentItem (e.g. a quiz question)
 *
 * Construct as follows:
 * <pre><code>
 * var myAssessmentItem = new new Intellify.Entities.AssessmentItem("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function AssessmentItemItem(id) {

  AssignableDigitalResource.call(this);

  this.setId(id);
  this.setType(this.Types.ASSESSMENT_ITEM);

  this.setProperties({});
}

AssessmentItemItem.prototype = _.create(AssignableDigitalResource.prototype);


module.exports = AssessmentItemItem;


})
, "./entities/media/mediaObject.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = __FAKE_REQUIRE__('../digitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/mediaObject.js");

/**
 *
 * Entity type: MediaObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/MediaObject
 *
 * Represents an MediaObject (this is a base class)
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.MediaObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function MediaObject(id) {

  DigitalResource.call(this);

  this.setId(id);
  this.setType(this.Types.MEDIA_OBJECT);

  this.setProperties({});
}

MediaObject.prototype = _.create(DigitalResource.prototype);

/**
 * Enum for JSON-LD types of media objects
 * @readonly
 * @enum {string}
 */
MediaObject.prototype.Types = {
  "AUDIO_OBJECT": "http://purl.imsglobal.org/caliper/v1/AudioObject",
  "IMAGE_OBJECT": "http://purl.imsglobal.org/caliper/v1/ImageObject",
  "VIDEO_OBJECT": "http://purl.imsglobal.org/caliper/v1/VideoObject",
  "MEDIA_LOCATION": "http://purl.imsglobal.org/caliper/v1/MediaLocation",
};

MediaObject.prototype.setDuration = function (duration) {
  this.duration = duration;
};

module.exports = MediaObject;


})
, "./entities/media/videoObject.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var MediaObject = __FAKE_REQUIRE__('./mediaObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/videoObject.js");

/**
 *
 * Entity type: VideoObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/VideoObject
 *
 * Represents an VideoObject
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.VideoObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function VideoObject(id) {

  MediaObject.call(this);

  this.setId(id);
  this.setType(this.Types.VIDEO_OBJECT);
}

VideoObject.prototype = _.create(MediaObject.prototype);

module.exports = VideoObject;


})
, "./entities/media/audioObject.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AudioObject = __FAKE_REQUIRE__('./AudioObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/audioObject.js");

/**
 *
 * Entity type: AudioObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/AudioObject
 *
 * Represents an AudioObject
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.AudioObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function AudioObject(id) {

  AudioObject.call(this);

  this.setId(id);
  this.setType(this.Types.AUDIO_OBJECT);
}

AudioObject.prototype = _.create(AudioObject.prototype);

module.exports = AudioObject;


})
, "./entities/media/AudioObject.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AudioObject = __FAKE_REQUIRE__('./AudioObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/AudioObject.js");

/**
 *
 * Entity type: AudioObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/AudioObject
 *
 * Represents an AudioObject
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.AudioObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function AudioObject(id) {

  AudioObject.call(this);

  this.setId(id);
  this.setType(this.Types.AUDIO_OBJECT);
}

AudioObject.prototype = _.create(AudioObject.prototype);

module.exports = AudioObject;


})
, "./entities/media/imageObject.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var MediaObject = __FAKE_REQUIRE__('./mediaObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/imageObject.js");

/**
 *
 * Entity type: ImageObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/ImageObject
 *
 * Represents an ImageObject
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.ImageObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function ImageObject(id) {

  MediaObject.call(this);

  this.setId(id);
  this.setType(this.Types.IMAGE_OBJECT);
}

ImageObject.prototype = _.create(MediaObject.prototype);

module.exports = ImageObject;


})
, "./entities/media/mediaLocation.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('./mediaObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/mediaLocation.js");

/**
 *
 * Entity type: MediaLocation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/MediaLocation
 *
 * Represents an location with a MediaObject (e.g. frame in a video, etc.)
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.MediaLocation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function MediaLocation(id) {

  Entity.call(this);

  this.setId(id);
  this.setType(this.Types.MEDIA_LOCATION);

  this.setName(null);
  this.setProperties({});
}

MediaLocation.prototype = _.create(Entity.prototype);

/**
 * Set the time offset from start
 *
 * @param {long} currentTime
 */
MediaLocation.prototype.setCurrentTime = function (currentTime) {
  this.currentTime = currentTime;
};

/**
 * Set the location offset from start
 *
 * @param {long} offset
 */
MediaLocation.prototype.offset = function (offset) {
  this.offset = offset;
};

module.exports = MediaLocation;


})
, "./entities/reading/ePubVolume.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = __FAKE_REQUIRE__('../digitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/reading/ePubVolume.js");

/**
 *
 * Entity type: EPubVolume
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/EPubVolume
 *
 * Represents a EPUB volume
 *
 * Construct as follows:
 * <pre><code>
 * var myEPubVolume = new new Intellify.Entities.EPubVolume("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function EPubVolume(id) {

  DigitalResource.call(this);

  this.setId(id);

  this.setName(null);
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
}

EPubVolume.prototype = _.create(DigitalResource.prototype);

module.exports = EPubVolume;

})
, "./entities/reading/frame.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = __FAKE_REQUIRE__('../digitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/reading/frame.js");

/**
 *
 * Entity type: Frame
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Frame
 *
 * Represents an Frame (base type for location within a DigitalResource. E.g. web page location)
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.Frame("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function Frame(id) {

  DigitalResource.call(this);

  this.setId(id);

  this.setName(null);
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
}

Frame.prototype = _.create(DigitalResource.prototype);

/**
 * Set the the index (location identifier)
 *
 * @param {long} index
 */
Frame.prototype.setIndex = function (index) {
  this.index = index;
};

module.exports = Frame;


})
, "./entities/session/session.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('../caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/session/session.js");

/**
 *
 * Entity type: Session
 * @extends Intellify.Entities.Entity
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Session
 *
 * Construct as follows:
 * <pre><code>
 * var mySession = new new Intellify.Entities.Session("ID_or_URI");
 * </pre></code>
 * @constructor
 */
function Session(id) {

    Entity.call(this);

    this.setId(id);
    this.setType(this.Types.SESSION);

    this.setProperties({});
}

Session.prototype = _.create(Entity.prototype);

/**
 * Set the session actor (typically a user)
 *
 * @param {object} actor
 */
Session.prototype.setActor = function(actor) {
    this.actor = actor;
};

/**
 * Set the session started at time
 *
 * @param {string} startedAtTime
 */
Session.prototype.setStartedAtTime = function(startedAt) {
    this.startedAtTime = startedAt;
};

/**
 * Set the session ended at time
 *
 * @param {string} endedAtTime
 */
Session.prototype.setEndedAtTime = function(endedAt) {
    this.endedAtTime = endedAt;
};

/**
 * Set the session duration
 *
 * @param {string} duration
 */
Session.prototype.setDuration = function(duration) {
    this.duration = duration;
};

module.exports = Session;


})
, "./entities/outcome/result.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = __FAKE_REQUIRE__('../caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/outcome/result.js");

/**
 *
 * Entity type: Result
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Result
 *
 * Represents an Result (outcome of an Attempt on a AssignableDigitalResource)
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.Result("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function Result(id) {

  Entity.call(this);

  this.setId(id);
  this.setType(this.Types.RESULT);

  this.setProperties({});
}

Result.prototype = _.create(Entity.prototype);

/**
 * Set the the actor (who's attempt is being reported on by Result)
 *
 * @param {string} actorId
 */
Result.prototype.setActorId = function (actorId) {
  this.actor = actorId;
};

/**
 * Set the the assignable (for which Result is being reported)
 *
 * @param {string} assignableId
 */
Result.prototype.setAssignableId = function (assignableId) {
  this.assignable = assignableId;
};

/**
 * Set the the lexile measure
 *
 * @param {long} lexileMeasure
 */
Result.prototype.setLexileMeasure = function (lexileMeasure) {
  this.lexileMeasure = lexileMeasure;
};

/**
 * Set the the normalScore
 *
 * @param {long} normalScore
 */
Result.prototype.setNormalScore = function (normalScore) {
  this.normalScore = normalScore;
};

/**
 * Set the the penaltyScore
 *
 * @param {long} penaltyScore
 */
Result.prototype.setPenaltyScore = function (penaltyScore) {
  this.penaltyScore = penaltyScore;
};

/**
 * Set the the extraCreditScore
 *
 * @param {long} extraCreditScore
 */
Result.prototype.setExtraCreditScore = function (extraCreditScore) {
  this.extraCreditScore = extraCreditScore;
};

/**
 * Set the the totalScore
 *
 * @param {long} totalScore
 */
Result.prototype.setTotalScore = function (totalScore) {
  this.totalScore = totalScore;
};

/**
 * Set the the curvedTotalScore
 *
 * @param {long} curvedTotalScore
 */
Result.prototype.setCurvedTotalScore = function (curvedTotalScore) {
  this.curvedTotalScore = curvedTotalScore;
};

/**
 * Set the the curveFactor
 *
 * @param {long} curveFactor
 */
Result.prototype.setCurveFactor = function (curveFactor) {
  this.curveFactor = curveFactor;
};

/**
 * Set any comments by scoree
 *
 * @param {string} comment
 */
Result.prototype.setComment = function (comment) {
  this.comment = comment;
};

/**
 * Set who scored tihs
 *
 * @param {Agent} scoredBy
 */
Result.prototype.setScoredBy = function (scoredBy) {
  this.scoredBy = scoredBy;
};

module.exports = Result;


})
, "./events/caliperEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 *
 * Events are used to describe the interaction between an Agent (user or system) with a object (learning activity).
 *
 *  As such, events are constructed with a triple - actor-action-object
 *
 *  In addition, interactions might also generate other objects (e.g. a student interacting with a Quiz will
 *  typically generate an Attempt).
 *
 *  Also, the actor might interact with an object to target another (e.g. a student might login to an edApp,
 *  with a target being a Quiz).
 *
 *  As a result, most events typically either specify a target or a generated object in addition to the actor-action-object triple
 *
 *  Events also can specify a startedAtTime and optionally an endedAtTime and a duration
 *
 *  Note that you would not typically use a generic Event, but rather a specific type (e.g. AssessmentEvent)
 *
 *  Here is an example:
 * <pre><code>
 * var assessmentEvent = new Event();
 * assessmentEvent.setActor(actor);
 * assessmentEvent.setAction(action);
 * assessmentEvent.setObject(quiz);
 * assessmentEvent.setGenerated(attempt);
 * assessmentEvent.setEdApp(edApp);
 * assessmentEvent.setLisOrganization(institution);
 * assessmentEvent.setStartedAtTime(1402965614516);
 * </pre></code>
 *  @constructor
 */
function Event() {
  // Constructor
}

/**
 * Set the event context
 * Note that this manifests as a JSON-LD @context. When you create one of the standard event types, the context and type are automatically set for you.
 * E.g. in the code below, the navigationEvent object has its context and type pre-set when you use the factory constructor
 *  new Intellify.Events.NavigationEvent()
 * <pre><code>
 * var actor = new Intellify.Entities.Person("https://some-university.edu/user/554433");
 * var navigationEvent = new Intellify.Events.NavigationEvent();
 * navigationEvent.setActor(actor);
 * </code></pre>
 *
 * @param {string} context - context URI
 */
Event.prototype.setContext = function(context) {
  this['@context'] = context;
};

/**
 * Set the event type
 * Note that this manifests as a JSON-LD @type
 *
 * @param {string} type - type URI
 */
Event.prototype.setType = function(type) {
  this['@type'] = type;
};

/**
 * Set the event actor
 *
 * E.g.
 * <pre><code>
 * var actor = new Intellify.Entities.Person("https://some-university.edu/user/554433");
 * var navigationEvent = new Intellify.Events.NavigationEvent();
 * navigationEvent.setActor(actor);
 * </code></pre>
 * @param {Intellify.Entities.Agent} actor - agent
 */
Event.prototype.setActor = function(actor) {
  this.actor = actor;
};

/**
 * Set the event action
 * Use the profile under Intellify.Actions
 *
 * E.g.
 * <pre><code>
 * // The Action for the Learning Event
 * var action = Intellify.Actions.ReadingActions.NAVIGATED_TO;
 * var navigationEvent = new Intellify.Events.NavigationEvent();
 * navigationEvent.setAction(action);
 * </code></pre>
 *
 * @param {string} actor - agent
 */
Event.prototype.setAction = function(action) {
  this.action = action;
};

/**
 * Set the event actor
 *
 * @param {Intellify.Entities.Agent} actor - agent
 */
Event.prototype.setObject = function(object) {
  this.object = object;
};

/**
 * Set the event target.
 *  Target types are specified by each Metric Profile
 *
 * @param {object} target - object representing target
 */
Event.prototype.setTarget = function(target) {
  this.target = target;
};

/**
 * Set the object generated by the event.
 *  Generated types are specified by each Metric Profile
 *
 * @param {object} generated - object representing generated
 */
Event.prototype.setGenerated = function(generated) {
  this.generated = generated;
};

/**
 * Set the time the event started at.
 *  A ISO-8601 date
 *
 * @param {string} startedAtTime - string representing datetime
 */
Event.prototype.setStartedAtTime = function(startedAt) {
  this.startedAtTime = startedAt;
};

/**
 * Set the time the event ended at
 *  A ISO-8601 date
 *
 * @param {string} startedAtTime - string representing datetime
 */
Event.prototype.setEndedAtTime = function(endedAt) {
  this.endedAtTime = endedAt;
};

/**
 * Set the duration of the event
 *  A ISO-8601 duration
 *
 * @param {string} duration - string representing duration
 */
Event.prototype.setDuration = function(duration) {
  this.duration = duration;
};

/**
 * Set the organization that the event occured in
 *  This is part of the "learning context" for the event. Organization is typically a course or class
 *
 * @param {Intellify.Entities.CourseSection} lisOrganization
 * @param {Intellify.Entities.Organization} lisOrganization
 */
Event.prototype.setLisOrganization = function(lisOrganization) {
  this.group = lisOrganization;
};

/**
 * Set the edApp that the event occured in
 *  This is part of the "learning context" for the event. edApp is typically a Software Application
 *
 * @param {Intellify.Entities.SoftwareApplication} edApp
 */
Event.prototype.setEdApp = function(edApp) {
  this.edApp = edApp;
};

/**
 * Enum for JSON-LD contexts for events
 * @readonly
 * @enum {string}
 */
Event.prototype.Contexts = {
  "ANNOTATION": "http://purl.imsglobal.org/ctx/caliper/v1/AnnotationEvent",
  "ASSESSMENT": "http://purl.imsglobal.org/ctx/caliper/v1/AssessmentEvent",
  "ASSESSMENT_ITEM": "http://purl.imsglobal.org/ctx/caliper/v1/AssessmentItemEvent",
  "ASSIGNABLE": "http://purl.imsglobal.org/ctx/caliper/v1/AssignableEvent",
  "EVENT": "http://purl.imsglobal.org/ctx/caliper/v1/Event",
  "MEDIA": "http://purl.imsglobal.org/ctx/caliper/v1/MediaEvent",
  "NAVIGATION": "http://purl.imsglobal.org/ctx/caliper/v1/NavigationEvent",
  "OUTCOME": "http://purl.imsglobal.org/ctx/caliper/v1/OutcomeEvent",
  "VIEWED": "http://purl.imsglobal.org/ctx/caliper/v1/ViewEvent",
  "SESSION": "http://purl.imsglobal.org/ctx/caliper/v1/SessionEvent"
};

/**
 * Enum for JSON-LD types of events
 * @readonly
 * @enum {string}
 */
Event.prototype.Types = {
  "ANNOTATION": "http://purl.imsglobal.org/caliper/v1/AnnotationEvent",
  "ASSESSMENT": "http://purl.imsglobal.org/caliper/v1/AssessmentEvent",
  "ASSESSMENT_ITEM": "http://purl.imsglobal.org/caliper/v1/AssessmentItemEvent",
  "ASSIGNABLE": "http://purl.imsglobal.org/caliper/v1/AssignableEvent",
  "EVENT": "http://purl.imsglobal.org/caliper/v1/Event",
  "MEDIA": "http://purl.imsglobal.org/caliper/v1/MediaEvent",
  "NAVIGATION": "http://purl.imsglobal.org/caliper/v1/NavigationEvent",
  "OUTCOME": "http://purl.imsglobal.org/caliper/v1/OutcomeEvent",
  "VIEWED": "http://purl.imsglobal.org/caliper/v1/ViewEvent",
  "SESSION": "http://purl.imsglobal.org/caliper/v1/SessionEvent"
};

module.exports = Event;


})
, "./events/annotationEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/annotationEvent.js");

/**
 *
 * Entity type: AnnotationEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/AnnotationEvent
 *
 * Represents an AnnotationEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.AnnotationEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function AnnotationEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.ANNOTATION);
  this.setType(this.Types.ANNOTATION);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

AnnotationEvent.prototype = _.create(LearningEvent.prototype);

module.exports = AnnotationEvent;


})
, "./events/assessmentEvent.js":
__MODULE_LOADER__(function(module, exports){

/*jshint -W079 */
"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/assessmentEvent.js");

/**
 *
 * Entity type: AssessmentEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/AssessmentEvent
 *
 * Represents an AssessmentEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.AssessmentEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function AssessmentEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.ASSESSMENT);
  this.setType(this.Types.ASSESSMENT);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

AssessmentEvent.prototype = _.create(LearningEvent.prototype);

module.exports = AssessmentEvent;


})
, "./events/assessmentItemEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/assessmentItemEvent.js");

/**
 *
 * Entity type: AssessmentItemEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/AssessmentItemEvent
 *
 * Represents an AssessmentItemEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.AssessmentItemEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function AssessmentItemEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.ASSESSMENT_ITEM);
  this.setType(this.Types.ASSESSMENT_ITEM);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

AssessmentItemEvent.prototype = _.create(LearningEvent.prototype);

module.exports = AssessmentItemEvent;


})
, "./events/assignableEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/assignableEvent.js");

/**
 *
 * Entity type: AssignableEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/AssignableEvent
 *
 * Represents an AssignableEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.AssignableEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function AssignableEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.ASSIGNABLE);
  this.setType(this.Types.ASSIGNABLE);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

AssignableEvent.prototype = _.create(LearningEvent.prototype);

module.exports = AssignableEvent;


})
, "./events/mediaEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/mediaEvent.js");

/**
 *
 * Entity type: MediaEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/MediaEvent
 *
 * Represents an MediaEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.MediaEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function MediaEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.MEDIA);
  this.setType(this.Types.MEDIA);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

MediaEvent.prototype = _.create(LearningEvent.prototype);

MediaEvent.prototype.setMediaLocation = function (mediaLocation) {
  this.mediaLocation = mediaLocation;
};

module.exports = MediaEvent;


})
, "./events/navigationEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/navigationEvent.js");

/**
 *
 * Entity type: NavigationEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/NavigationEvent
 *
 * Represents an NavigationEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.NavigationEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function NavigationEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.NAVIGATION);
  this.setType(this.Types.NAVIGATION);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

NavigationEvent.prototype = _.create(LearningEvent.prototype);

NavigationEvent.prototype.setNavigatedFrom = function (navigatedFrom) {
  this.navigatedFrom = navigatedFrom;
};

module.exports = NavigationEvent;


})
, "./events/outcomeEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/outcomeEvent.js");

/**
 *
 * Entity type: OutcomeEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/OutcomeEvent
 *
 * Represents an OutcomeEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.OutcomeEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function OutcomeEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.OUTCOME);
  this.setType(this.Types.OUTCOME);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

OutcomeEvent.prototype = _.create(LearningEvent.prototype);

module.exports = OutcomeEvent;


})
, "./events/sessionEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/sessionEvent.js");

/**
 *
 * Entity type: SessionEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/SessionEvent
 *
 * Represents an SessionEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.SessionEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function SessionEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.SESSION);
  this.setType(this.Types.SESSION);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

SessionEvent.prototype = _.create(LearningEvent.prototype);

module.exports = SessionEvent;


})
, "./events/viewEvent.js":
__MODULE_LOADER__(function(module, exports){

"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = __FAKE_REQUIRE__('./caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/viewEvent.js");

/**
 *
 * Entity type: ViewEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/ViewEvent
 *
 * Represents an ViewEvent
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.ViewEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function ViewEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.VIEWED);
  this.setType(this.Types.VIEWED);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

ViewEvent.prototype = _.create(LearningEvent.prototype);

module.exports = ViewEvent;


})
    };         var __CI_MODULE_PATH_MAP__ = {     "/users/pnayak/documents/workspace/intellisense-js-2/src/intellisense.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/asyncclient.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/asyncClient.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/cors.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/cors.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/logger.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/logger.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/annotationactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/annotationActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/assessmentactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/assessmentActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/assessmentitemactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/assessmentItemActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/assignableactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/assignableActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/mediaactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/mediaActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/outcomeactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/outcomeActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/readingactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/readingActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/actions/sessionactions.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/actions/sessionActions.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/caliperentity.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/caliperEntity.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/agent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/agent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/digitalresource.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/DigitalResource.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/learningobjective.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/learningObjective.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/softwareapplication.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/softwareApplication.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/webpage.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/webPage.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/user.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/user.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/lis/person.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/lis/person.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/lis/coursesection.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/lis/courseSection.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/lis/organization.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/lis/organization.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/annotation/annotation.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/annotation.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/annotation/bookmarkannotation.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/bookmarkAnnotation.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/annotation/highlightannotation.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/highlightAnnotation.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/annotation/sharedannotation.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/sharedAnnotation.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/annotation/tagannotation.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/annotation/tagAnnotation.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/assignable/assignabledigitalresource.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assignable/assignableDigitalResource.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/assignable/attempt.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assignable/attempt.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/assessment/assessment.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assessment/assessment.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/assessment/assessmentitem.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/assessment/assessmentItem.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/media/mediaobject.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/mediaObject.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/media/videoobject.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/videoObject.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/media/audioobject.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/AudioObject.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/media/imageobject.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/imageObject.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/media/medialocation.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/media/mediaLocation.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/reading/epubvolume.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/reading/ePubVolume.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/reading/frame.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/reading/frame.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/session/session.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/session/session.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/entities/outcome/result.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/entities/outcome/result.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/caliperevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/caliperEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/annotationevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/annotationEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/assessmentevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/assessmentEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/assessmentitemevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/assessmentItemEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/assignableevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/assignableEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/mediaevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/mediaEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/navigationevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/navigationEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/outcomeevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/outcomeEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/sessionevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/sessionEvent.js"
, "/users/pnayak/documents/workspace/intellisense-js-2/src/events/viewevent.js":
"/Users/pnayak/Documents/workspace/intellisense-js-2/src/events/viewEvent.js"
    };         var Path = require("path");    var resolveRelativePath = function (from, to) {

    var relPath = Path.relative(from, to);
    if (!/^[\./\\]/.test(relPath) && !/:\//.test(relPath)) {
        relPath = './' + relPath;
    }

    // Normalize path if possible
    if (relPath.indexOf(':') === -1) {
        relPath = relPath.replace(/\\/g, '/');
    }

    return relPath;

};     var __MAIN_ORIGINAL_PATH__ = "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js";        var __LOOK_FOR_FILE__ = function (relPath) {        var module = __REQUIRED_NODE_MODULES__.hasOwnProperty(relPath) ? __REQUIRED_NODE_MODULES__[relPath] : null;        if (!module) {            relPath = __CI_MODULE_PATH_MAP__[relPath];            if (relPath) {                module = __REQUIRED_NODE_MODULES__.hasOwnProperty(relPath) ? __REQUIRED_NODE_MODULES__[relPath] : null;            }        }        return module;    };        var __FAKE_REQUIRE__ = function (modulePath, originalModulePath) {        if (!__CORE_MODULE_LIST__.hasOwnProperty(modulePath)) {            /* Transform path to distribution path */            var relPath;            if (originalModulePath) {                relPath = Path.resolve(Path.dirname(originalModulePath), modulePath);                relPath = resolveRelativePath(Path.dirname(__MAIN_ORIGINAL_PATH__), relPath);            } else {                relPath = resolveRelativePath(__dirname, modulePath);            }                        /* Try inlined modules */            var module = __LOOK_FOR_FILE__(relPath) || __LOOK_FOR_FILE__(relPath + '.js') || __LOOK_FOR_FILE__(relPath + '.json');            if (module) return module();                        /* Try original `require` with transformed path */            try {                return require(relPath);            } catch (e) {            }        }                /* Try original `require` with original statement */        return require(modulePath);    };        this.__FAKE_REQUIRE__ = __FAKE_REQUIRE__;     })();"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var client = __FAKE_REQUIRE__('./asyncClient', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
var logger = __FAKE_REQUIRE__('./logger', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Grab an existing namespace object
// or create a blank object if it doesn't exist
// so we can attach non-sensor module exports to it
var Intellify = {};
if (typeof window !== "undefined") {
  if (!_.isUndefined(window.Intellify)) {
    Intellify = window.Intellify;
  }
}

// The sensor itself
var IntelliSense = {};

/**
 * Initializes the default client to use. Uses the socket consumer by default.
 * @param  array $options passed straight to the client
 */
IntelliSense.initialize = function(options) {
  if (!_.isUndefined(options)) {
    client.initialize(options);
  }
};


/**
 * Send learning events
 * @deprecated since version 1.0.9
 * @param  CaliperEvent $caliperEvent The Learning Event
 * @return boolean                   whether the measure call succeeded
 */
IntelliSense.measure = function(caliperEvent) {
  client.measure(caliperEvent);
};

/**
 * Send learning events
 * @param  CaliperEvent $caliperEvent The Learning Event
 * @return boolean                   whether the send call succeeded
 */
IntelliSense.send = function(caliperEvent) {
  client.measure(caliperEvent);
};

/**
 * Describe an entity
 * @param  CaliperEntity $caliperEntity The Intellify Entity we are describing
 * @return boolean            whether the describe call succeeded
 */
IntelliSense.describe = function(caliperEntity) {
  client.describe(caliperEntity);
};

/**
 * Login and return authentication token
 * @param  User $user The user (name and password) to login
 * @param long $expiryInSeconds Token expiration duration in seconds
 * @param Function $successCallback Success callback function
 * @param Function $errorCallback Error callback function
 */
IntelliSense.authenticate = function(user, expiryInSeconds, successCallback,
  errorCallback) {
  var successFunction = function(token) {
    successCallback(token);
  };

  var errorFunction = function(message) {
    logger.log("Error in authentication : " + message);
    errorCallback(message);
  };
  client.authenticate(user, expiryInSeconds, successFunction, errorFunction);
};

/**
 * refresh authentication token
 * The call can be made only for authenticated users.
 * @param  String $token user authorization token
 * @param long $expiryInSeconds Token expiration duration in seconds
 * @param Function $successCallback Success callback function
 * @param Function $errorCallback Error callback function
 */
IntelliSense.refreshToken = function(token, expiryInSeconds, successCallback,
  errorCallback) {
  var successFunction = function(token) {
    successCallback(token);
  };

  var errorFunction = function(message) {
    logger.log("Error in refresh token : " + message);
    errorCallback(message);
  };
  client.refreshToken(token, expiryInSeconds, successFunction, errorFunction);
};

/**
 * Query an Intellify stream and return the result.
 * The call can be made only for authenticated users.
 * Hence, we need to call authenticate before placing any query
 * @param String $token user authorization token
 * @param String $stream Name of the stream to be searched
 * @param boolean $isDynamic True if this is dynamic query
 * @param String $urlParams URL parameters if any
 * @param String $requestBody JSON query string which will be the request body
 * @param Function $successCallback Success callback function
 * @param Function $errorCallback Error callback function
 */
IntelliSense.query = function(token, stream, isDynamic, urlParams, requestBody,
  successCallback, errorCallback) {
  var successFunction = function(data) {
    successCallback(data);
  };

  var errorFunction = function(message) {
    logger.log("Error while querying : " + message);
    errorCallback(message);
  };
  client.query(token, stream, isDynamic, urlParams, requestBody, successFunction,
    errorFunction);
};

// Stick on the modules that need to be exported under the Intellify namespace
// You only need to require the top-level modules. Browserify
// will walk the dependency graph and load everything correctly
Intellify.Actions = {};
Intellify.Entities = {};
Intellify.Events = {};

// ACTIONS
Intellify.Actions.AnnotationActions = __FAKE_REQUIRE__('./actions/annotationActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.AssessmentActions = __FAKE_REQUIRE__('./actions/assessmentActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.AssessmentItemActions = __FAKE_REQUIRE__(
  './actions/assessmentItemActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.AssignableActions = __FAKE_REQUIRE__('./actions/assignableActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.MediaActions = __FAKE_REQUIRE__('./actions/mediaActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.OutcomeActions = __FAKE_REQUIRE__('./actions/outcomeActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.ReadingActions = __FAKE_REQUIRE__('./actions/readingActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Actions.SessionActions = __FAKE_REQUIRE__('./actions/sessionActions', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");


// ENTITIES
Intellify.Entities.Entity = __FAKE_REQUIRE__('./entities/caliperEntity', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Core entities
Intellify.Entities.Agent = __FAKE_REQUIRE__('./entities/agent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.DigitalResource = __FAKE_REQUIRE__('./entities/digitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.LearningObjective = __FAKE_REQUIRE__('./entities/learningObjective', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.SoftwareApplication = __FAKE_REQUIRE__(
  './entities/softwareApplication', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.WebPage = __FAKE_REQUIRE__('./entities/webPage', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

//User
Intellify.Entities.User = __FAKE_REQUIRE__('./entities/user', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// LIS entities

Intellify.Entities.Person = __FAKE_REQUIRE__('./entities/lis/person', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

Intellify.Entities.CourseSection = __FAKE_REQUIRE__('./entities/lis/courseSection', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

Intellify.Entities.Organization = __FAKE_REQUIRE__('./entities/lis/organization', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Annotation entities
Intellify.Entities.Annotation = __FAKE_REQUIRE__('./entities/annotation/annotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.BookmarkAnnotation = __FAKE_REQUIRE__(
  './entities/annotation/bookmarkAnnotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.HighlightAnnotation = __FAKE_REQUIRE__(
  './entities/annotation/highlightAnnotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.SharedAnnotation = __FAKE_REQUIRE__(
  './entities/annotation/sharedAnnotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.TagAnnotation = __FAKE_REQUIRE__(
  './entities/annotation/tagAnnotation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Assignable and Assessement entities
Intellify.Entities.AssignableDigitalResource = __FAKE_REQUIRE__(
  './entities/assignable/assignableDigitalResource', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.Attempt = __FAKE_REQUIRE__('./entities/assignable/attempt', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.Assessment = __FAKE_REQUIRE__('./entities/assessment/assessment', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.AssessmentItem = __FAKE_REQUIRE__(
  './entities/assessment/assessmentItem', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Media Entities
Intellify.Entities.MediaObject = __FAKE_REQUIRE__('./entities/media/mediaObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.VideoObject = __FAKE_REQUIRE__('./entities/media/videoObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.AudioObject = __FAKE_REQUIRE__('./entities/media/audioObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.ImageObject = __FAKE_REQUIRE__('./entities/media/imageObject', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.MediaLocation = __FAKE_REQUIRE__('./entities/media/mediaLocation', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Reading Entities
Intellify.Entities.EPubVolume = __FAKE_REQUIRE__('./entities/reading/ePubVolume', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Entities.Frame = __FAKE_REQUIRE__('./entities/reading/frame', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Session Entities
Intellify.Entities.Session = __FAKE_REQUIRE__('./entities/session/session', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Outcome Entities
Intellify.Entities.Result = __FAKE_REQUIRE__('./entities/outcome/result', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// EVENTS
Intellify.Events.Event = __FAKE_REQUIRE__('./events/caliperEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.AnnotationEvent = __FAKE_REQUIRE__('./events/annotationEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.AssessmentEvent = __FAKE_REQUIRE__('./events/assessmentEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.AssessmentItemEvent = __FAKE_REQUIRE__('./events/assessmentItemEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.AssignableEvent = __FAKE_REQUIRE__('./events/assignableEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.MediaEvent = __FAKE_REQUIRE__('./events/mediaEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.NavigationEvent = __FAKE_REQUIRE__('./events/navigationEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.OutcomeEvent = __FAKE_REQUIRE__('./events/outcomeEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.SessionEvent = __FAKE_REQUIRE__('./events/sessionEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");
Intellify.Events.ViewEvent = __FAKE_REQUIRE__('./events/viewEvent', "/Users/pnayak/Documents/workspace/intellisense-js-2/src/intellisense.js");

// Replace/Create the global namespace and objects (the sensor) we want there
Intellify.Sensor = IntelliSense;

// Replace/create Intellify in global namespace
var win = (typeof window !== "undefined") ? window : undefined;
if (!_.isUndefined(win)) {
  win.Intellify = Intellify;
  logger.log("Added sensor to window global %o", window.Intellify);
  logger.info("Browser mode: intellisense-js available to window global as Intellify");
} else {
  logger.info("Browser mode: intellisense-js NOT made available to window global as Intellify");
}

//logger.log('info', "CommonJS mode: intellisense-js exported as Intellify");
module.exports = Intellify;
