"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = require('./caliperEntity');

/**
 *
 * Entity type: Agent 
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Agent
 *
 * Construct as follows:
 * <pre><code>
 * var myUser = new new Intellify.Entities.Agent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function Agent(id, type) {

  Entity.call(this);

  this.setId(id);

  switch (type) {
  case "LIS_PERSON":
    this.setType("http://purl.imsglobal.org/caliper/v1/lis/Person");
    break;
  case "LIS_COURSE_SECTION":
    this.setType("http://purl.imsglobal.org/caliper/v1/lis/CourseSection");
    break;
  case "LIS_ORGANIZATION":
    this.setType("http://purl.imsglobal.org/caliper/v1/lis/Organization");
    break;
  case "SOFTWARE_APPLICATION":
    this.setType("http://purl.imsglobal.org/caliper/v1/SoftwareApplication");
    break;
  }

  this.setName(null);
  this.setDescription(null);
  this.setProperties({});
}

Agent.prototype = _.create(Entity.prototype);

module.exports = Agent;
