"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = require('./annotation');

/**
 *
 * Entity type: BookmarkAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/BookmarkAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var myBookmarkAnnotation = new new Intellify.Entities.BookmarkAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function BookmarkAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

BookmarkAnnotation.prototype = _.create(Annotation.prototype);

BookmarkAnnotation.prototype.setBookmarkNotes = function (bookmarkNotes) {
  this.bookmarkNotes = bookmarkNotes;
};

module.exports = BookmarkAnnotation;
