"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = require('./annotation');

/**
 *
 * Entity type: HighlightAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/HighlightAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var myHighlightAnnotation = new new Intellify.Entities.HighlightAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function HighlightAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

HighlightAnnotation.prototype = _.create(Annotation.prototype);

HighlightAnnotation.prototype.setSelection = function (selection) {
  this.selection = selection;
};

HighlightAnnotation.prototype.setSelectionText = function (selectionText) {
  this.selectionText = selectionText;
};

module.exports = HighlightAnnotation;
