"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = require('./annotation');

/**
 *
 * Entity type: SharedAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/SharedAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var mySharedAnnotation = new new Intellify.Entities.SharedAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function SharedAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

SharedAnnotation.prototype = _.create(Annotation.prototype);

SharedAnnotation.prototype.setWithAgents = function (withAgents) {
  this.withAgents = withAgents;
};

module.exports = SharedAnnotation;
