"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Annotation = require('./annotation');

/**
 *
 * Entity type: TagAnnotation
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/TagAnnotation
 *
 * Construct as follows:
 * <pre><code>
 * var myTagAnnotation = new new Intellify.Entities.TagAnnotation("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Annotation
 */
function TagAnnotation(id) {

  Annotation.call(this);

  this.setId(id);
}

TagAnnotation.prototype = _.create(Annotation.prototype);

TagAnnotation.prototype.setTags = function (tags) {
  this.tags = tags;
};

module.exports = TagAnnotation;
