"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AssignableDigitalResource = require('../assignable/assignableDigitalResource');

/**
 *
 * Entity type: Assessment
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Assessment
 *
 * Represents an Assessment (e.g. a quiz, homework)
 *
 * Construct as follows:
 * <pre><code>
 * var myAssessment = new new Intellify.Entities.Assessment("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function Assessment(id) {

  AssignableDigitalResource.call(this);

  this.setId(id);
  this.setType(this.Types.ASSESSMENT);

  this.setProperties({});
}

Assessment.prototype = _.create(AssignableDigitalResource.prototype);

Assessment.prototype.setAssessmentItems = function (assessmentItems) {
  this.assessmentItems = assessmentItems;
};

module.exports = Assessment;
