"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AssignableDigitalResource = require('../assignable/assignableDigitalResource');

/**
 *
 * Entity type: AssessmentItem
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/AssessmentItem
 *
 * Represents an AssessmentItem (e.g. a quiz question)
 *
 * Construct as follows:
 * <pre><code>
 * var myAssessmentItem = new new Intellify.Entities.AssessmentItem("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function AssessmentItemItem(id) {

  AssignableDigitalResource.call(this);

  this.setId(id);
  this.setType(this.Types.ASSESSMENT_ITEM);

  this.setProperties({});
}

AssessmentItemItem.prototype = _.create(AssignableDigitalResource.prototype);


module.exports = AssessmentItemItem;
