"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Entity = require('./caliperEntity');

/**
 *
 * Entity type: LearningObjective
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/LearningObjective
 *
 * Construct as follows:
 * <pre><code>
 * var aLearningObjective = new new Intellify.Entities.LearningObjective("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function LearningObjective(id) {

  Entity.call(this);

  this.setId(id);
  this.setType(this.Types.LEARNING_OBJECTIVE);

  this.setName(null);
  this.setProperties({});
}

LearningObjective.prototype = _.create(Entity.prototype);

module.exports = LearningObjective;
