"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Organization = require('./organization');

/**
 *
 * Entity type: CourseSection
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/CourseSection
 *
 * Represents an CourseSection (e.g. a class, section, )
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.CourseSection("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Organization
 */
function CourseSection(id) {

  Organization.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/lis/CourseSection");

  this.setParentOrg(null);

}

CourseSection.prototype = _.create(Organization.prototype);

CourseSection.prototype.setSemester = function(semester) {
  this.semester = semester;
};

CourseSection.prototype.setCourseNumber = function(courseNumber) {
  this.courseNumber = courseNumber;
};

CourseSection.prototype.setLabel = function(label) {
  this.label = label;
};

module.exports = CourseSection;
