"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Agent = require('../agent');

/**
 *
 * Entity type: Organization
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/Organization
 *
 * Represents an Organization (e.g. a School, College, etc.)
 *
 * Construct as follows:
 * <pre><code>
 * var myOrganization = new new Intellify.Entities.Organization("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Agent
 */
function Organization(id) {

  Agent.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/lis/Organization");

  this.setName(null);
}

Organization.prototype = _.create(Agent.prototype);

Organization.prototype.setParentOrg = function(parentOrg) {
  this.parentOrg = parentOrg;
};

module.exports = Organization;
