"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var AudioObject = require('./AudioObject');

/**
 *
 * Entity type: AudioObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/AudioObject
 *
 * Represents an AudioObject
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.AudioObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function AudioObject(id) {

  AudioObject.call(this);

  this.setId(id);
  this.setType(this.Types.AUDIO_OBJECT);
}

AudioObject.prototype = _.create(AudioObject.prototype);

module.exports = AudioObject;
