"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var MediaObject = require('./mediaObject');

/**
 *
 * Entity type: VideoObject
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/VideoObject
 *
 * Represents an VideoObject 
 *
 * Construct as follows:
 * <pre><code>
 * var myCourseSection = new new Intellify.Entities.VideoObject("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.MediaObject
 */
function VideoObject(id) {

  MediaObject.call(this);

  this.setId(id);
  this.setType(this.Types.VIDEO_OBJECT);
}

VideoObject.prototype = _.create(MediaObject.prototype);

module.exports = VideoObject;
