"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = require('../digitalResource');

/**
 *
 * Entity type: EPubVolume
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/EPubVolume
 *
 * Represents a EPUB volume
 *
 * Construct as follows:
 * <pre><code>
 * var myEPubVolume = new new Intellify.Entities.EPubVolume("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.DigitalResource
 */
function EPubVolume(id) {

  DigitalResource.call(this);

  this.setId(id);

  this.setName(null);
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
}

EPubVolume.prototype = _.create(DigitalResource.prototype);

module.exports = EPubVolume;