"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var Agent = require('./agent');

/**
 *
 * Entity type: SoftwareApplication
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/SoftwareApplication
 *
 * Construct as follows:
 * <pre><code>
 * var myEdApp = new new Intellify.Entities.SoftwareApplication("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function SoftwareApplication(id) {

  Agent.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/SoftwareApplication");

}

SoftwareApplication.prototype = _.create(Agent.prototype);

module.exports = SoftwareApplication;
