"use strict";
/**
 *  @author Sachin Kulkarni
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

/**
 *
 * User entity to encapsulate login credentials
 *
 * <pre><code>
 * var user = new User("user_name", "user_password");
 * <pre><code>
 *  @constructor
 */
function User(name, password) {
  this.setUserName(name);
  this.setUserPassword(password);
}

/**
 * Set the username
 *
 * @param {string} name - user name
 */
User.prototype.setUserName = function(name) {
  this.username = name;
};

/**
 * Set the password
 *
 * @param {string} password - user password
 */
User.prototype.setUserPassword = function(password) {
  this.password = password;
};

module.exports = User;
