"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var DigitalResource = require('./digitalResource');

/**
 *
 * Entity type: WebPage
 *
 * JSON-LD type: http://purl.imsglobal.org/caliper/v1/WebPage
 *
 * Construct as follows:
 * <pre><code>
 * var myWebPage = new new Intellify.Entities.WebPage("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Entities.Entity
 */
function WebPage(id) {

  DigitalResource.call(this);

  this.setId(id);
  this.setType("http://purl.imsglobal.org/caliper/v1/WebPage");

  this.setName(null);
  this.setObjectType([]);
  this.setAlignedLearningObjective([]);
  this.setKeywords([]);
  this.setIsPartOf(null);
}

WebPage.prototype = _.create(DigitalResource.prototype);

module.exports = WebPage;
