"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = require('./caliperEvent');

/**
 *
 * Entity type: MediaEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/MediaEvent
 *
 * Represents an MediaEvent 
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.MediaEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function MediaEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.MEDIA);
  this.setType(this.Types.MEDIA);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

MediaEvent.prototype = _.create(LearningEvent.prototype);

MediaEvent.prototype.setMediaLocation = function (mediaLocation) {
  this.mediaLocation = mediaLocation;
};

module.exports = MediaEvent;
