"use strict";
/**
 *  @author Prashant Nayak
 *  @copyright ©2015 Intellify Learning.  All Rights Reserved.
 *  @license For license information contact, info@intellifylearning.org
 */

var _ = require('lodash-node');
var LearningEvent = require('./caliperEvent');

/**
 *
 * Entity type: OutcomeEvent
 *
 * JSON-LD type: http://purl.imsglobal.org/ctx/caliper/v1/OutcomeEvent
 *
 * Represents an OutcomeEvent 
 *
 * Construct as follows:
 * <pre><code>
 * var event = new new Intellify.Events.OutcomeEvent("ID_or_URI");
 * </pre></code>
 * @constructor
 * @extends Intellify.Events.Event
 */
function OutcomeEvent() {

  LearningEvent.call(this);

  this.setContext(this.Contexts.OUTCOME);
  this.setType(this.Types.OUTCOME);

  this.setGenerated(null);
  this.setStartedAtTime(0);
  this.setEndedAtTime(0);
  this.setDuration(null);
}

OutcomeEvent.prototype = _.create(LearningEvent.prototype);

module.exports = OutcomeEvent;
