"use strict";

var _ = require('lodash-node');
var console;

if (!_.isUndefined(global) && global.console) {
  console = global.console;
} else if (!_.isUndefined(window) && window.console) {
  console = window.console;
} else {
  console = {};
}

var functions = [
  [log, "log"],
  [info, "info"],
  [warn, "warn"],
  [error, "error"]
];

for (var i = 0; i < functions.length; i++) {
  var tuple = functions[i];
  var f = tuple[0];
  var n = tuple[1];

  if (!console[n]) {
    console[n] = f;
  }
}

module.exports = console;

function log() {}

function info() {
  console.log.apply(console, arguments);
}

function warn() {
  console.log.apply(console, arguments);
}

function error() {
  console.warn.apply(console, arguments);
}
